/*
 * Created on 27 juin 2006
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.sat4j.tools;

import java.io.PrintStream;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Map;

import org.sat4j.specs.ContradictionException;
import org.sat4j.specs.IConstr;
import org.sat4j.specs.ISolver;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;
import org.sat4j.specs.TimeoutException;

/**
 * Solver used to display in a writer the CNF instance in Dimacs format.
 * 
 * That solver is useful to produce CNF files to be used by third party solvers.
 * 
 * @author leberre
 *
 */
public class DimacsOutputSolver implements ISolver {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private PrintWriter out;
	private int nbvars;
	private int nbclauses;
	
	public DimacsOutputSolver() {
		this(new PrintWriter(System.out));
	}
	
	public DimacsOutputSolver(PrintWriter pw) {
		out = pw;
	}
	
    public int newVar() {
        return 0;
    }

    public int newVar(int howmany) {
        out.print("p cnf "+howmany);
        nbvars = howmany;
        return 0;
    }

    public void setExpectedNumberOfClauses(int nb) {
    	out.println(" "+nb);
    	nbclauses = nb;
    }

    public IConstr addClause(IVecInt literals) throws ContradictionException {
        for (int i : literals)
            out.print(i+" ");
        out.println("0");
        return null;
    }

    public boolean removeConstr(IConstr c) {
         throw new UnsupportedOperationException();
    }

    public void addAllClauses(IVec<IVecInt> clauses)
            throws ContradictionException {
    	throw new UnsupportedOperationException();
    }

    public IConstr addAtMost(IVecInt literals, int degree)
            throws ContradictionException {
       out.println(literals.toString()+" <= "+degree);
        return null;
    }

    public IConstr addAtLeast(IVecInt literals, int degree)
            throws ContradictionException {
        out.println(literals.toString()+" >= "+degree);
        return null;
    }

    public IConstr addPseudoBoolean(IVecInt lits, IVec<BigInteger> coeffs,
            boolean moreThan, BigInteger d) throws ContradictionException {
    	throw new UnsupportedOperationException();
    }

    public void setTimeout(int t) {
        // TODO Auto-generated method stub

    }

    public int getTimeout() {
        // TODO Auto-generated method stub
        return 0;
    }
    
    public void expireTimeout() {
    	// TODO Auto-generated method stub
    }

    public void reset() {
        // TODO Auto-generated method stub

    }

    public void printStat(PrintStream out, String prefix) {
        // TODO Auto-generated method stub

    }

    public void printStat(PrintWriter out, String prefix) {
        // TODO Auto-generated method stub

    }

    public Map<String, Number> getStat() {
        // TODO Auto-generated method stub
        return null;
    }

    public String toString(String prefix) {
        // TODO Auto-generated method stub
        return null;
    }

    public void clearLearntClauses() {
        // TODO Auto-generated method stub

    }

    public int[] model() {
    	throw new UnsupportedOperationException();
    }

    public boolean model(int var) {
    	throw new UnsupportedOperationException();
    }

    public boolean isSatisfiable() throws TimeoutException {
    	throw new TimeoutException("There is no real solver behind!");
    }

    public boolean isSatisfiable(IVecInt assumps) throws TimeoutException {
    	throw new TimeoutException("There is no real solver behind!");
    }

    public int[] findModel() throws TimeoutException {
    	throw new UnsupportedOperationException();
    }

    public int[] findModel(IVecInt assumps) throws TimeoutException {
    	throw new UnsupportedOperationException();
    }

    public int nConstraints() {
        return nbclauses;
    }

    public int nVars() {
        // TODO Auto-generated method stub
        return nbvars;
    }

}
